library(igraph)

karate <- make_graph("Zachary")

#figer les sommets
lay <- layout.fruchterman.reingold(karate)
plot(karate,  layout = lay)

#fonction modularity et communities
web <- cluster_edge_betweenness(karate)
eweb <- edge.betweenness.community(karate)
modularity(web)
membership(web)
#transformer en attribut du graphe
V(karate)$ceb <- membership(web)

par(mfrow=c(1,2), mar=c(2,0.2,1.4,0.2))

plot(as.dendrogram(web))
plot(web, karate, layout = lay)

dev.off()

wc <- cluster_walktrap(karate)
modularity(wc)

ws <- cluster_spinglass(karate)
modularity(ws)

wl <- cluster_louvain(karate)
modularity(wl)

wfg <- cluster_fast_greedy(karate)
modularity(wfg)

wo <- cluster_optimal(karate)
modularity(wo)

wlp <- cluster_label_prop(karate)
modularity(wlp)

wle <- cluster_leading_eigen(karate)
modularity(wle)

inf <- cluster_infomap(karate)
modularity(inf)

par(mfrow = c(2,2), mar=c(0.2,0.2,1.4,0.2))

plot(wc, karate,  layout = lay,
     main = paste("Walktrap", round(modularity(wc),2), sep = " "))
plot(ws, karate,  layout = lay,
     main = paste("Spinglass", round(modularity(ws),2), sep = " "))
plot(wl, karate,  layout = lay,
     main = paste("Louvain", round(modularity(wl),2), sep = " "))
plot(wlp, karate, layout = lay,
     main = paste("Label propagation", round(modularity(wlp),2), sep = " "))
plot(web, karate, layout = lay, 
     main = paste("Edge betweenness", round(modularity(web),2), sep = " "))

plot(wle, karate, layout = lay,
     main = paste("Eigenvector", round(modularity(wle),2), sep = " "))
plot(wo, karate, layout = lay, 
     main = paste("Optimal", round(modularity(wo),2), sep = " "))
plot(wfg, karate, layout = lay, 
     main = paste("Fast greedy", round(modularity(wfg),2), sep = " "))
plot(inf, karate, layout = lay, 
     main = paste("Infomap", round(modularity(inf),2), sep = " "))

dev.off()

